
"""
Script to find IPv4 prefixes in the file

This script finds all prefixes and saves them info the output file.
All prefixes matching pattern X.X.X.X/X are added.
Prefixes which match pattern X.X.X.X and are at the begining of a line in the input file are added as X.X.X.X/32
"""

import sys, os, datetime, re

today = datetime.datetime.now()

vstup = (sys.argv[1])
f = open(vstup, 'r')

prefixy = []

for line in f:
  #print line
  # add prefixes X.X.X.X/X
  prefixes_found = re.findall("\d+\.\d+\.\d+\.\d+/\d+", line)
  for prefix in prefixes_found:
    prefixy.append(prefix)
  
  # add prefixes X.X.X.X not followed by "/"    - the script will add prefix X.X.X.X/32
  for possible_prefix in re.finditer("\d+\.\d+\.\d+\.\d+\s", line):
    # we have found an IP address not followed by "/"
    if possible_prefix.start() < 4:
      # it is at the begining of the line - it is a prefix      
      prefixy.append(possible_prefix.group(0).strip() + "/32")
      #print "adding " + possible_prefix.group(0) + "/32"

f.close

number_of_prefixes = str(len(prefixy))

# save all the parsed prefixes
output_filename = today.strftime("%Y-%m-%d_" + sys.argv[1] + "_" + number_of_prefixes )
output = open("./out/" + output_filename, 'w')
for prefix in prefixy:
	output.write(prefix)
	output.write("\n")
