"""
Script to find IPv6 prefixes in the file downloaded from sixxs.net

This script finds all prefixes and saves them info the output file.
All prefixes which are "OK" (white in the web page on sixxs.net) or "80-100% of the GRH participants saw this route" (light orange) are added.
"""


import sys, os, datetime

today = datetime.datetime.now()

input_file = (sys.argv[1])
f = open(input_file, 'r')

prefixes = []
	
string = f.read()
pozice = string.find("<table cellspacing=\"0\" cellpadding=\"0\" class=\"normal\">")

string = string[pozice:]
#print odriznutej
prefixes_to_examine = string.split("<tr")
#print string[1]
#print prefixes_to_examine
for prefix_to_examine in prefixes_to_examine:
	if prefix_to_examine.find("\"background-color: ") != -1:
		# this prefix is not white - it is not ok. If it is light orange (80-100% GRH saw this route), we will accept it
			if prefix_to_examine.find("\"background-color: #ffee99\"") == -1:
				# This prefix is not "ok" (is not white) and 80-100% GRH didn't see this route (is not light orange)
				continue;

	# This record is ok, we have to crop just the prefix
	zacatek = prefix_to_examine.find("title=\"Lookup prefix in whois database\">")
	konec = prefix_to_examine.find("</a>", zacatek + 5)
	if zacatek != -1:
		prefix = prefix_to_examine[zacatek+40:konec]
		# add the cropped prefix into prefixes
		prefixes.append(prefix)
			
number_of_prefixes = str(len(prefixes))

# save all the parsed prefixes
output_filename = today.strftime("%Y-%m-%d_SIXXS-" + sys.argv[1] + "_" + number_of_prefixes )
output = open("./out/" + output_filename, 'w')
for prefix in prefixes:
	output.write(prefix)
	output.write("\r\n")

