"""
Script to find IPv6 prefixes in the file

This script finds all prefixes and saves them info the output file.
All prefixes matching pattern X+:+[X:]* and are at the begining of a line in the input file are added.
"""

import sys, os, datetime, re

today = datetime.datetime.now()

vstup = (sys.argv[1])
f = open(vstup, 'r')

prefixy = []

for line in f:
  # Find strings that match the pattern. They will be added if they are at the begining of a line
  for possible_prefix in re.finditer("[\dABCDEFabcdef]+[:]+[\dABCDEFabcdef:/]*\s", line):
    # we have found an IP address
    if possible_prefix.start() < 5:
      # it is at the begining of the line - it is a prefix      
      if prefixy.count(possible_prefix.group(0).strip()) < 1:
        prefixy.append(possible_prefix.group(0).strip())
        #print "adding " + possible_prefix.group(0)

f.close

number_of_prefixes = str(len(prefixy))

# save all the parsed prefixes
output_filename = today.strftime("%Y-%m-%d_" + sys.argv[1] + "_" + number_of_prefixes )
output = open("./out/" + output_filename, 'w')
for prefix in prefixy:
	output.write(prefix)
	output.write("\r\n")

