###############################################################################
#  example_of_use.py: Module for PATTERN MATCH - example of use for DCAM based
#                     string matching
#  Copyright (C) 2012 Brno University of Technology, ANT @ FIT
#  Author(s): Vlastimil Kosar <ikosar@fit.vutbr.cz>
###############################################################################
#
#  LICENSE TERMS
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#  1. Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#  2. Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in
#     the documentation and/or other materials provided with the
#     distribution.
#  3. All advertising materials mentioning features or use of this software
#     or firmware must display the following acknowledgement:
#
#       This product includes software developed by the University of
#       Technology, Faculty of Information Technology, Brno and its
#       contributors.
#
#  4. Neither the name of the Company nor the names of its contributors
#     may be used to endorse or promote products derived from this
#     software without specific prior written permission.
#
#  This software or firmware is provided ``as is'', and any express or implied
#  warranties, including, but not limited to, the implied warranties of
#  merchantability and fitness for a particular purpose are disclaimed.
#  In no event shall the company or contributors be liable for any
#  direct, indirect, incidental, special, exemplary, or consequential
#  damages (including, but not limited to, procurement of substitute
#  goods or services; loss of use, data, or profits; or business
#  interruption) however caused and on any theory of liability, whether
#  in contract, strict liability, or tort (including negligence or
#  otherwise) arising in any way out of the use of this software, even
#  if advised of the possibility of such damage.
#
#  $Id$

# Import used Netbench modules
from netbench.pattern_match.algorithms.experimental.dcam import dcam 

"""
    This module demonstrate usage of dcam class.
"""

if __name__ == '__main__':
    # DCAM based string matching
    print("-------------------------------------------------------------------")
    print("                    DCAM based string matching                     ")
    print("-------------------------------------------------------------------")
    print(" Ruleset: ./test/tests/test.str                                    ")
    print(" Genereated VHDL output: dcam.vhd                                  ")
    print("-------------------------------------------------------------------")
    # Create dcam object
    dcm = dcam.dcam()
    # Load string file
    dcm.load_from_file("./test/tests/test.str")
    # Call the compute method
    dcm.compute()
    # Get number of used LUTs and FFs
    data = dcm.report_logic()
    print(" Used LUTs estimation: " + str(data[0]))
    print(" Used FFs estimation: " + str(data[1]))
    print("-------------------------------------------------------------------")
    # Save implementation
    # Open file
    f = open("dcam.vhd", "w")
    # Get VHDL code and write the code
    f.write(dcm.get_HDL())
    # Close file
    f.close()
